src/Variant10/Pages/Error.cshtml.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using System.Diagnostics;

namespace Variant10.Pages
{
    [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
    [IgnoreAntiforgeryToken]
    public class ErrorModel : PageModel
    {
        public string RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);

        public ErrorModel()
        {
        }

        public void OnGet()
        {
            RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier;
        }
    }
}

src/Variant10/Pages/Index.cshtml.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.EntityFrameworkCore;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Variant10.DbModel;
using Variant10.NhlApi;

namespace Variant10.Pages
{
    public class IndexModel : PageModel
    {
        private readonly ILogger<IndexModel> _logger;
        private readonly GamesContext _gamesContext;
        private readonly INhlApiService _nhlApi;

        [BindProperty]
        public IEnumerable<Game> Games { get; set; }

        public const string MessageKey = nameof(MessageKey);
        public const bool DbError = false;

        public IndexModel(ILogger<IndexModel> logger, GamesContext context, INhlApiService nhlapi)
        {
            _logger = logger;
            _gamesContext = context;
            _nhlApi = nhlapi;
        }

        private void SetDBerror()
        {
            TempData[nameof(DbError)] = true;
            TempData[MessageKey] = _gamesContext.DataSource;
        }

        public async Task OnGetAsync(int month = 1, bool table = true)
        {
            if (_gamesContext.IsAvailable)
            {
                try
                {
                    if (_gamesContext.Games.Any())
                    {
                        _logger.LogInformation("Getting games...");

                        //Need to explicit load teams as top players can be from any team (not only from home or away)!
                        _gamesContext.Teams.Load();

                        var games = await _gamesContext.Games.Include(t => t.TopPlayers).ToListAsync();

                        //Fix month 01 - 1 = 12
                        var reqDate = DateTime.Now.AddMonths(-month);
                        Games = games.Where(d => d.GameDate.Month == reqDate.Month && d.GameDate.Year == reqDate.Year);

                        if (!Games.Any())
                            TempData[MessageKey] = $"No games matching {Utils.GetPrettyDate(reqDate)}, update from API!";
                    }
                    else
                        TempData[MessageKey] = "No games in DB, update from API!";

                }
                catch (Exception ex)
                {
                    _logger.LogError(ex.Message);
                    SetDBerror();
                }
            }
            else
            {
                SetDBerror();
            }

            TempData[nameof(table)] = table;
            TempData[nameof(month)] = month;
        }

        public async Task<IActionResult> OnPostUpdate(int month = 1)
        {
            if (_gamesContext.IsAvailable)
            {
                await EnsureTeams();

                _logger.LogInformation("Updating data...");
                var games = await _nhlApi.GetGamesAsync(month);

                foreach (var game in games)
                {
                    var existingGame = _gamesContext.Games.SingleOrDefault(g => g.Pk == game.Pk);

                    if (existingGame != null)
                    {
                        _logger.LogInformation($"Game alredy exist in db: {game.Pk}");
                        continue;
                    }

                    _gamesContext.Games.Add(game);
                }

                await _gamesContext.SaveChangesAsync();

                TempData[MessageKey] = "Database updated from API";
            }

            return RedirectToAction(Request.Path, new { table = Request.Query["table"].ToString(), month = Request.Query["month"].ToString() });
        }

        private async Task EnsureTeams()
        {
            if (!_gamesContext.Teams.Any())
            {
                var teams = await _nhlApi.GetTeamsAsync();

                foreach (var team in teams)
                {
                    _gamesContext.Teams.Add(team);
                }

                await _gamesContext.SaveChangesAsync();
            }
        }

        public async Task<IActionResult> OnPostClear()
        {
            if (_gamesContext.IsAvailable)
            {
                _logger.LogInformation("Clearing data...");
                _gamesContext.Games.RemoveRange(_gamesContext.Games);
                await _gamesContext.SaveChangesAsync();
            }

            return RedirectToAction(Request.Path, new { table = Request.Query["table"].ToString() });
        }

        public async Task<IActionResult> OnPostReconnect()
        {
            _logger.LogInformation("Reconnecting to DB...");

            _gamesContext.IsAvailable = await _gamesContext.Database.CanConnectAsync();

            if (_gamesContext.IsAvailable)
                _gamesContext.Database.EnsureCreated();

            return RedirectToAction(Request.Path);
        }
    }
}

src/Variant10/Pages/About.cshtml
@page

@using Variant10.DbModel;
@using Variant10.NhlApi;
@using Microsoft.Extensions.Options

@model ErrorModel
@inject Microsoft.AspNetCore.Hosting.IWebHostEnvironment hostEnv
@inject IOptions<NhlApiSettings> AppSettings
@{
    ViewData["Title"] = "About";
    var _apiRoot = AppSettings.Value.ApiRoot;
}

@inject GamesContext _context;

<div class="text-center">
    <h2 class="display-4">@ViewData["Title"]</h2>
</div>

<div class="col-md-7 container justify-content-center">
    <div class="col">

        See <a title="GitLab" href="https://gitlab.com/Maxx53/variant10" target="_blank" rel="noopener">Variant10 on GitLab</a>. Made with .NET @Environment.Version. Used libraries and tools:
        <ul>
            <li><a title="Entity Framework" href="https://docs.microsoft.com/ru-ru/ef/" target="_blank" rel="noopener">Entity Framework</a></li>
            <li><a title="MySQL" href="https://www.mysql.com" target="_blank" rel="noopener">MySQL</a></li>
            <li><a title="Bootstrap" href="https://getbootstrap.com/" target="_blank" rel="noopener">Bootstrap</a></li>
        </ul>

        Used <a href="https://gitlab.com/dword4/nhlapi">NHL API</a> links:
        <ul>
            <li><a title="Teams" href="@_apiRoot/teams" target="_blank" rel="noopener">Teams</a></li>
            <li><a title="Schedule" href="@NhlApiService.GenGamesUrl(1, _apiRoot, AppSettings.Value.HomeId)" target="_blank" rel="noopener">Schedule</a></li>
            <li><a title="Game-boxscore" href="@_apiRoot/game/2021020788/boxscore" target="_blank" rel="noopener">Game-boxscore</a></li>
        </ul>

        <p id="mydesc"><strong>Host Information</strong></p>
        <table class="table table-sm" aria-describedby="mydesc" aria-hidden="true">
            <tbody>
                <tr>
                    <td>Hostname</td>
                    <td>@Environment.MachineName</td>
                </tr>
                <tr>
                    <td>OS</td>
                    <td>@System.Runtime.InteropServices.RuntimeInformation.OSDescription</td>
                </tr>
                <tr>
                    <td>IP-address</td>
                    <td>@HttpContext.Connection.LocalIpAddress</td>
                </tr>
                <tr>
                    <td>DB address</td>
                    <td>@_context.DataSource</td>
                </tr>
                <tr>
                    <td>App version</td>
                    <td>@GetType().Assembly.GetName().Version.ToString()</td>
                </tr>
                <tr>
                    <td>Environment</td>
                    <td>@hostEnv.EnvironmentName</td>
                </tr>
            </tbody>
        </table>
        <br />
        <div class="text-center">
            <p><a asp-page="/Index">Back to Index</a></p>
        </div>
    </div>
</div>

src/Variant10/Pages/Index.cshtml
@page
@model IndexModel
@{
    ViewData["Title"] = "Home page";

    var isTable = TempData["table"] as bool? ?? false;
    var viewName = isTable ? "Table" : "List";
    var buttonName = isTable ? "List" : "Table";
    var month = TempData["month"] as int? ?? 1;
}

<div class="text-center">
    <h2 class="display-4">Variant 10</h2>
    <p>To attract hockey fans to marketing campaign you will need to find all games happened in St. Louis during previous month (e.g. if now is March 05, 2021 last month means Feb 2021) and print a list of it with score and top 3 player by time on ice. Use <a href="https://gitlab.com/dword4/nhlapi">API</a> and store all the collected data in a local database.</p>


    @if (TempData["DbError"] is bool dbError)
    {
        if (dbError && TempData[IndexModel.MessageKey] is string dataSource)
        {
            <div class="row justify-content-md-center">
                <div class="col-md-8 alert alert-danger" role="alert">
                    DB server @dataSource is not available!
                </div>
            </div>

            <form asp-antiforgery="false" method="POST">
                <input type="hidden" />
                <input type="submit" value="Reconnect to DB" class="btn btn-info" asp-page-handler="Reconnect" />
            </form>
        }
    }
    else
    {
        <form asp-antiforgery="false" method="POST">
            <input type="hidden" />
            <input type="submit" value="Update DB from API" class="btn btn-info" asp-page-handler="Update" asp-route-table="@Request.Query["table"]" asp-route-month="@Request.Query["month"]" />
            <input type="submit" value="Clear DB" class="btn btn-danger" asp-page-handler="Clear" asp-route-table="@Request.Query["table"]" />
            <a asp-page="Index" asp-route-table="@(!isTable)" asp-route-month="@month" class="btn btn-light">@buttonName View</a>
        </form>

        <br />

        @if (TempData[IndexModel.MessageKey] is string message)
        {
            <div class="row justify-content-md-center">
                <div class="col-md-4 alert alert-success" role="alert">
                    @message
                </div>
            </div>
        }

        @if (Model.Games != null && Model.Games.Any())
        {
            <style>

                hr {
                    margin-top: 0;
                }

                ol {
                    font-weight: bolder;
                    margin: 0;
                    padding: 0;
                }

                    ol li span {
                        font-weight: normal;
                    }

                td {
                    vertical-align: middle !important;
                }
            </style>

            <div style="font-size: 34px;">Games in @Utils.GetPrettyDate(DateTime.Now.AddMonths(-month))</div><br />
            <partial name="~/Pages/Views/@(viewName).cshtml" model="@Model" />
        }
    }

</div>

src/Variant10/Pages/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Variant10</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
</head>
<body>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container text-center">
            &copy; @DateTime.Now.Year - Variant10 - <a asp-page="/About">About</a>
        </div>
    </footer>

    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>

    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>